/*
 * messasy
 *
 * Copyright (C) 2006,2007,2008 DesigNET, INC.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

/*
 * $RCSfile: log.h,v $
 * $Revision: 1.9 $
 * $Date: 2009/01/27 05:54:45 $
 */

#define SYSLOG_IDENT "messasy"

#define ERR_CONFIG_NULL			"%s: Config is null."
#define ERR_CONFIG_MAILDIR_NULL		"%s: MailDir is not set."
#define ERR_CONFIG_MAILFOLDER_NULL	"%s: MailFolder is not set."
#define ERR_CONFIG_RELOADING	"%s: Cannot reload config(%s): (still refered)"

#define ERR_CONFIG_FILE_OPEN	"%s: Cannot open config file.(%s): (%s)"
#define ERR_CONFIG_LINE_LONG	"%s: %s (line: %d) is too long."
#define ERR_CONFIG_DUPLICATED	"%s: %s (line: %d) is duplicated. (%s)"
#define ERR_CONFIG_SYNTAX	"%s: %s (line: %d) syntax error. (%s)"
#define ERR_CONFIG_OUT_OF_RANGE	"%s: %s (line: %d) is too large. (%s)"
#define ERR_CONFIG_VALUE_MINUS	"%s: %s (line: %d) must be plus. (%s)"
#define ERR_CONFIG_UNKNOWN_NAME	"%s: %s (line: %d) is unknown data type."
#define ERR_CONFIG_MUST_BE_SET	"%s: Parameter \"%s\" must be set. (%s)"

#define ERR_SOCKET_READ			"%s: Cannot read from socket.: (%s)"
#define ERR_SOCKET_CONNECT		"%s: Cannot connect socket.: (%s)"
#define ERR_SOCKET_CLOSE		"%s: Cannot close socket.: (%s)"
#define ERR_SOCKET_CREATE		"%s: Cannot create socket.: (%s)"
#define ERR_SOCKET_SET_OPTION		"%s: Cannot set socket option.: (%s)"
#define ERR_SOCKET_BIND			"%s: Cannot bind socket.: (%s)"
#define ERR_SOCKET_LISTEN		"%s: Cannot listen socket.: (%s)"
#define ERR_SOCKET_ACCEPT		"%s: Cannot accept socket.: (%s)"

#define ERR_MILTER_SET_SOCKET		"%s: Cannot set milter socket.: (%s)"
#define ERR_MILTER_SET_TIMEOUT		"%s: Cannot set milter timeout.: (%s)"
#define ERR_MILTER_REGISTER		"%s: Cannot set milter register.: (%s)"
#define ERR_MILTER_START		"%s: Cannot start milter.: (%s)"

#define ERR_MAIL_FORMAT			"%s: Mailformat error.: (%s)"
#define ERR_MAIL_FIND_ADDRESS		"%s: Not found mail address."

#define ERR_FILE_RENAME		"%s: Cannot rename.(%s): (%s)"
#define ERR_FILE_GET_INFO	"%s: Cannot get file information.(%s): (%s)"
#define ERR_FILE_CREATE_TMPFILE	"%s: Cannot create tmpfile.(%s): (%s)"

#define ERR_DIRECTORY_MAKE		"%s: Cannot make directory.(%s): (%s)"
#define ERR_DIRECTORY_NOT_DIRECTORY	"%s: Not directory.(%s)"

#define ERR_IO_WRITE			"%s: Cannot write.: (%s)"
#define ERR_IO_READ			"%s: Cannot read.: (%s)"

#define ERR_THREAD_CREATE	"%s: Cannot create thread.(%s): (%s)"
#define ERR_THREAD_DETACH	"%s: Cannot detach thread.(%s): (%s)"

#define ERR_KERNEL_GET_INFO	"%s: Cannot get kernel information.: (%s)"
#define ERR_MEMORY_ALLOCATE	"%s: Cannot allocate memory.(variable=%s): (%s)"
#define ERR_TIME_LOCALTIME		"%s: Cannot localtime.: (%s)"

#define ERR_ENCODE_MEMORY_ALLOCATE	"%s: Cannot allocate memory for encoding.: (%s)"

#define ERR_MAILADDR_UNKNOWN_TYPE	"%s: Non-ascii characters are included in mail address.: (%s)"

int syslog_facility(char *str);
void init_log();
void switch_log(char *);
void errorlog(char *, ...);
void systemlog(char *, ...);
int (*logfunc)(const char *, ...);

#define log (*logfunc)

